"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
class Consumer extends React.Component {
    constructor() {
        super(...arguments);
        this.key = undefined;
    }
    componentDidMount() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            this.checkManager();
            yield Promise.resolve();
            this.key = (_a = this.props.manager) === null || _a === void 0 ? void 0 : _a.mount(this.props.children);
        });
    }
    componentDidUpdate() {
        var _a;
        this.checkManager();
        (_a = this.props.manager) === null || _a === void 0 ? void 0 : _a.update(this.key, this.props.children);
    }
    componentWillUnmount() {
        var _a;
        this.checkManager();
        (_a = this.props.manager) === null || _a === void 0 ? void 0 : _a.unmount(this.key);
    }
    checkManager() {
        if (!this.props.manager) {
            throw new Error('No portal manager defined');
        }
    }
    render() {
        return null;
    }
}
exports.Consumer = Consumer;
