import * as React from 'react';
import { ViewStyle } from 'react-native';
import { IManager } from './Manager';
interface IProps {
    children: React.ReactNode;
    style?: ViewStyle;
}
export interface IProvider {
    mount(children: React.ReactNode): number;
    update(key: number, children: React.ReactNode): void;
    unmount(key: number): void;
}
export declare const Context: React.Context<IProvider | null>;
export declare class Host extends React.Component<IProps> {
    nextKey: number;
    queue: {
        type: 'mount' | 'update' | 'unmount';
        key: number;
        children?: React.ReactNode;
    }[];
    manager: IManager | null;
    componentDidMount(): void;
    mount: (children: React.ReactNode) => number;
    update: (key: number, children: React.ReactNode) => void;
    unmount: (key: number) => void;
    render(): JSX.Element;
}
export {};
