"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_native_1 = require("react-native");
class Manager extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = { portals: [] };
        this.mount = (key, children) => {
            this.setState(state => ({
                portals: [...state.portals, { key, children }],
            }));
        };
        this.update = (key, children) => {
            this.setState(state => ({
                portals: state.portals.map(item => {
                    if (item.key === key) {
                        return Object.assign(Object.assign({}, item), { children });
                    }
                    return item;
                }),
            }));
        };
        this.unmount = (key) => {
            this.setState(state => ({
                portals: state.portals.filter(item => item.key !== key),
            }));
        };
    }
    render() {
        return this.state.portals.map(({ key, children }) => (React.createElement(react_native_1.View, { key: key, collapsable: false, pointerEvents: "box-none", style: react_native_1.StyleSheet.absoluteFill }, children)));
    }
}
exports.Manager = Manager;
